<?php

namespace dgsoft\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TravelClubType StructType
 * @package Dg
 * @subpackage Structs
 */
class DgTravelClubType extends AbstractStructBase
{
    /**
     * The TravelClubName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgCompanyNameType
     */
    public $TravelClubName;
    /**
     * The ClubMemberName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgClubMemberName
     */
    public $ClubMemberName;
    /**
     * The ShareSynchInd
     * @var string
     */
    public $ShareSynchInd;
    /**
     * The ShareMarketInd
     * @var string
     */
    public $ShareMarketInd;
    /**
     * The EffectiveDate
     * @var string
     */
    public $EffectiveDate;
    /**
     * The ExpireDate
     * @var string
     */
    public $ExpireDate;
    /**
     * Constructor method for TravelClubType
     * @uses DgTravelClubType::setTravelClubName()
     * @uses DgTravelClubType::setClubMemberName()
     * @uses DgTravelClubType::setShareSynchInd()
     * @uses DgTravelClubType::setShareMarketInd()
     * @uses DgTravelClubType::setEffectiveDate()
     * @uses DgTravelClubType::setExpireDate()
     * @param \dgsoft\StructType\DgCompanyNameType $travelClubName
     * @param \dgsoft\StructType\DgClubMemberName $clubMemberName
     * @param string $shareSynchInd
     * @param string $shareMarketInd
     * @param string $effectiveDate
     * @param string $expireDate
     */
    public function __construct(\dgsoft\StructType\DgCompanyNameType $travelClubName = null, \dgsoft\StructType\DgClubMemberName $clubMemberName = null, $shareSynchInd = null, $shareMarketInd = null, $effectiveDate = null, $expireDate = null)
    {
        $this
            ->setTravelClubName($travelClubName)
            ->setClubMemberName($clubMemberName)
            ->setShareSynchInd($shareSynchInd)
            ->setShareMarketInd($shareMarketInd)
            ->setEffectiveDate($effectiveDate)
            ->setExpireDate($expireDate);
    }
    /**
     * Get TravelClubName value
     * @return \dgsoft\StructType\DgCompanyNameType|null
     */
    public function getTravelClubName()
    {
        return $this->TravelClubName;
    }
    /**
     * Set TravelClubName value
     * @param \dgsoft\StructType\DgCompanyNameType $travelClubName
     * @return \dgsoft\StructType\DgTravelClubType
     */
    public function setTravelClubName(\dgsoft\StructType\DgCompanyNameType $travelClubName = null)
    {
        $this->TravelClubName = $travelClubName;
        return $this;
    }
    /**
     * Get ClubMemberName value
     * @return \dgsoft\StructType\DgClubMemberName|null
     */
    public function getClubMemberName()
    {
        return $this->ClubMemberName;
    }
    /**
     * Set ClubMemberName value
     * @param \dgsoft\StructType\DgClubMemberName $clubMemberName
     * @return \dgsoft\StructType\DgTravelClubType
     */
    public function setClubMemberName(\dgsoft\StructType\DgClubMemberName $clubMemberName = null)
    {
        $this->ClubMemberName = $clubMemberName;
        return $this;
    }
    /**
     * Get ShareSynchInd value
     * @return string|null
     */
    public function getShareSynchInd()
    {
        return $this->ShareSynchInd;
    }
    /**
     * Set ShareSynchInd value
     * @param string $shareSynchInd
     * @return \dgsoft\StructType\DgTravelClubType
     */
    public function setShareSynchInd($shareSynchInd = null)
    {
        // validation for constraint: string
        if (!is_null($shareSynchInd) && !is_string($shareSynchInd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($shareSynchInd)), __LINE__);
        }
        $this->ShareSynchInd = $shareSynchInd;
        return $this;
    }
    /**
     * Get ShareMarketInd value
     * @return string|null
     */
    public function getShareMarketInd()
    {
        return $this->ShareMarketInd;
    }
    /**
     * Set ShareMarketInd value
     * @param string $shareMarketInd
     * @return \dgsoft\StructType\DgTravelClubType
     */
    public function setShareMarketInd($shareMarketInd = null)
    {
        // validation for constraint: string
        if (!is_null($shareMarketInd) && !is_string($shareMarketInd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($shareMarketInd)), __LINE__);
        }
        $this->ShareMarketInd = $shareMarketInd;
        return $this;
    }
    /**
     * Get EffectiveDate value
     * @return string|null
     */
    public function getEffectiveDate()
    {
        return $this->EffectiveDate;
    }
    /**
     * Set EffectiveDate value
     * @param string $effectiveDate
     * @return \dgsoft\StructType\DgTravelClubType
     */
    public function setEffectiveDate($effectiveDate = null)
    {
        // validation for constraint: string
        if (!is_null($effectiveDate) && !is_string($effectiveDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($effectiveDate)), __LINE__);
        }
        $this->EffectiveDate = $effectiveDate;
        return $this;
    }
    /**
     * Get ExpireDate value
     * @return string|null
     */
    public function getExpireDate()
    {
        return $this->ExpireDate;
    }
    /**
     * Set ExpireDate value
     * @param string $expireDate
     * @return \dgsoft\StructType\DgTravelClubType
     */
    public function setExpireDate($expireDate = null)
    {
        // validation for constraint: string
        if (!is_null($expireDate) && !is_string($expireDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($expireDate)), __LINE__);
        }
        $this->ExpireDate = $expireDate;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\StructType\DgTravelClubType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
